unit uAdmassess_Shift_Consults;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons, Miscfp;

type
  TfrmConsults = class(TForm)
    lblLabel1: TLabel;    lblLabel2: TLabel;     lblLabel3: TLabel;     lblLabel4: TLabel;
    lblLabel5: TLabel;    lblLabel6: TLabel;     lblLabel7: TLabel;
    lblDysLabel: TLabel;  lblDPLabel: TLabel;    lblHoldlabel: TLabel;  lblSWLabel: TLabel;
    lblPTLabel: TLabel;   lblNutrLabel: TLabel;  lblSkinLabel: TLabel;  lblPodLabel: TLabel;
    lblOTLabel: TLabel;   lblChapLabel: TLabel;  lblHCLabel: TLabel;    lblTeleLabel: TLabel;
    lblRespLabel: TLabel;   lblRehabLabel: TLabel;     lblNRLabel: TLabel;      lblWHLabel: TLabel;
    lblDiabNLabel: TLabel;  lblNotifyLabelEP: TLabel;  lblNotifyLabel: TLabel;  lblMHLabel: TLabel;
    lblWoundLabel: TLabel;
    cbxComboBox1: TComboBox;    cbxComboBox2: TComboBox;
    edtEdit1: TEdit;    edtEdit2: TEdit;    edtEdit3: TEdit;
    chkCheckBox1: TCheckBox;
    memMemo1: TMemo;
    btnUploadButton: TButton;
    btnCancelbutton: TBitBtn;
    rgrpRadioGroup1: TRadioGroup;
    lstListBox1: TListBox;    lstListBox2: TListBox;
    pnlButtons: TPanel;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnCancelbuttonClick(Sender: TObject);
    procedure btnUploadButtonClick(Sender: TObject);
    procedure edtEdit2Change(Sender: TObject);
    procedure edtEdit3Change(Sender: TObject);
    procedure Err(S:String;  var OK:Boolean);
    procedure Invis;
    procedure lstListBox1Click(Sender: TObject);
    procedure lstListBox2Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
private
    { Private declarations }
    Nochange:Boolean;
    U:Char;
    procedure PTVis(B: Boolean);
    procedure Addtonotify(S: String);
  public
    { Public declarations }
    Eprov,Prov:TStringlist;
    Lb1index,Lb2index:Integer;
    procedure ChapVis(B: Boolean);
    procedure NRestVis(B: Boolean);
    procedure NutrVis(B: Boolean);
    procedure RehabVis(B: Boolean);
    procedure RespVis(B: Boolean);
    procedure RestVis(B: Boolean);
    procedure SkinVis(B: Boolean);
    procedure SWVis(B: Boolean);
  end;

var
  frmConsults: TfrmConsults;

implementation

uses uAdmassess_Shift_Main, uAdmassess_Shift_Error_screen;

{$R *.DFM}


procedure TfrmConsults.FormCreate(Sender: TObject);
begin
  EProv:=TStringlist.Create;  Prov:=TStringlist.Create;  Nochange:=False;  U:='^';
end;


procedure TfrmConsults.btnCancelbuttonClick(Sender: TObject);
begin
  cbxCombobox1.Text:='Routine';   cbxCombobox2.Text:='Bedside';  edtEdit1.Clear;  memMemo1.Clear;
  rgrpRadiogroup1.Itemindex:=-1;  chkCheckbox1.Checked:=False;   Invis;
  Close;
end;


procedure TfrmConsults.btnUploadButtonClick(Sender: TObject);
var OK:Boolean;
begin
  frmError.lstListbox1.Clear;  OK:=True;
  If memMemo1.Lines.Count=0 then Err('Reason',OK);
  If rgrpRadiogroup1.Itemindex=-1 then Err('Inpat/Outpat',OK);
  If EProv.Count=0 then Err('Encounter provider',Ok);
  If lstListbox2.Visible then Err('Encounter provider',Ok);
  If OK then begin
    btnUploadButton.Enabled:=False;  btnCancelButton.Enabled:=False;
    Mb('Looks good.  Consult will be uploaded with the note.','I');
    If frmConsults.Caption=lblChapLabel.Caption then begin
      ChapVis(True);  Addtonotify('CHAP');
    end;
    If frmConsults.Caption=lblDiabNLabel.Caption then begin
      Form1.lblGU3Label10.Visible:=True;  Addtonotify('DIABN');
    end;
    If frmConsults.Caption=lblDPLabel.Caption then begin
      Form1.lblDP2Label9.Visible:=True;  Addtonotify('DP');
    end;
    If frmConsults.Caption=lblDysLabel.Caption then begin
      Form1.lblGI3Label18.Visible:=True;  Addtonotify('DYS');
    end;
    If frmConsults.Caption=lblHCLabel.Caption then begin
      Form1.lblDP2Label12.Visible:=True;  Addtonotify('DP');
    end;
    If frmConsults.Caption=lblNRLabel.Caption then begin
      NRestVis(True);  Addtonotify('NR');
    end;
    If frmConsults.Caption=lblNutrLabel.Caption then begin
      NutrVis(True);  Addtonotify('NUTR');
    end;
    If frmConsults.Caption=lblPTLabel.Caption then begin
      PTVis(True);  Addtonotify('PT');
    end;
    If frmConsults.Caption=lblRespLabel.Caption then begin
      RespVis(True);  Addtonotify('RESP');
    end;
    If frmConsults.Caption=lblRehabLabel.Caption then begin
      RehabVis(True);  Addtonotify('REHAB');
    end;
    If frmConsults.Caption=lblSkinLabel.Caption then begin
      SkinVis(True);  Addtonotify('SKIN');
    end;
    If frmConsults.Caption=lblSWLabel.Caption then begin
      SWVis(True);    Addtonotify('SW');
    end;
    If frmConsults.Caption=lblTeleLabel.Caption then begin
      Form1.lblDP2Label11.Visible:=True;  Addtonotify('DP');
    end;
    If frmConsults.Caption=lblWHLabel.Caption then begin
      Form1.lblGU2Label19.Visible:=True;  Addtonotify('WH');
    end;
    If frmConsults.Caption=lblWoundLabel.Caption then begin
      Form1.lblSkin4Label17.Visible:=True;  Addtonotify('WOUND');
    end;
    chkCheckbox1.Checked:=True;  Close;
  end
  else begin
    Invis;
    frmError.lblLabel1.Caption:='  Cannot Upload '+frmConsults.Caption+'.  The following errors were found:  ';
    frmError.lstCheckListbox1.Visible:=False;
    frmError.lstListbox1.Visible:=True;
    frmError.Showmodal;
  end;
end;


procedure TfrmConsults.Invis;
begin
  If frmConsults.Caption=lblChapLabel.Caption then ChapVis(False);
  If frmConsults.Caption=lblDiabNLabel.Caption then Form1.lblGU3Label10.Visible:=False;
  If frmConsults.Caption=lblDPLabel.Caption then Form1.lblDP2Label9.Visible:=False;
  If frmConsults.Caption=lblDysLabel.Caption then Form1.lblGI3Label18.Visible:=False;
  If frmConsults.Caption=lblHCLabel.Caption then Form1.lblDP2Label12.Visible:=False;
  If frmConsults.Caption=lblNRLabel.Caption then NRestVis(False);
  If frmConsults.Caption=lblNutrLabel.Caption then NutrVis(False);
  If frmConsults.Caption=lblPTLabel.Caption then PTVis(False);
  If frmConsults.Caption=lblRehabLabel.Caption then RehabVis(False);
  If frmConsults.Caption=lblRespLabel.Caption then RespVis(False);
  If frmConsults.Caption=lblSkinLabel.Caption then SkinVis(False);
  If frmConsults.Caption=lblSWLabel.Caption then SWVis(False);
  If frmConsults.Caption=lblTeleLabel.Caption then Form1.lblDP2Label11.Visible:=False;
  If frmConsults.Caption=lblWHLabel.Caption then Form1.lblGU2Label19.Visible:=False;
  If frmConsults.Caption=lblWoundLabel.Caption then Form1.lblSkin4Label17.Visible:=False;
end;


procedure TfrmConsults.ChapVis(B:Boolean);
begin
  Form1.lblGen2Label19.Visible:=B;
end;


procedure TfrmConsults.NRestVis(B:Boolean);
begin
  Form1.lblMusc3Label17.Visible:=B;
end;


procedure TfrmConsults.NutrVis(B:Boolean);
begin
  Form1.lblSkin4Label16.Visible:=B;
  Form1.lblGI2Label33.Visible:=B;
end;


procedure TfrmConsults.PTVis(B:Boolean);
begin
  Form1.lblMusc3Label16.Visible:=B;
end;


procedure TfrmConsults.RehabVis(B:Boolean);
begin
  Form1.lblMusc3Label16.Visible:=B;
end;


procedure TfrmConsults.RespVis(B:Boolean);
begin
  Form1.lblResp2Label21.Visible:=B;
end;


procedure TfrmConsults.RestVis(B:Boolean);
begin
  Form1.lblMusc3Label17.Visible:=B;
end;


procedure TfrmConsults.SWVis(B:Boolean);
begin
  Form1.lblGen3Label10.Visible:=B;  Form1.lblPsy1Label16.Visible:=B;  
  Form1.lblPsy3Label15.Visible:=B;  Form1.lblDP2Label10.Visible:=B;
end;


procedure TfrmConsults.SkinVis(B:Boolean);
begin
  Form1.lblSkin4Label17.Visible:=B;
end;


procedure TfrmConsults.Err(S:String;  var OK:Boolean);
begin
  frmError.lstListbox1.Items.Add(S+' not specified.');  OK:=False;
end;


procedure TfrmConsults.edtEdit2Change(Sender: TObject);
var I:Integer;
begin
  If Not frmConsults.Visible then exit;
  lstListBox1.Visible:=(Length(edtEdit2.Text)>2);
  If (lstListBox1.Items.Count=1) and (edtEdit2.Text=lstListBox1.Items[0]) then Lb1index:=0;
  If (Not Nochange) and (lstListBox1.Visible) then begin
    Prov.Clear;  lstListBox1.Items.Clear;  Lb1index:=-1;
    Form1.Rpccallforlookup('200',edtEdit2.Text,'','','','');
    For I:=1 to Form1.brkrRpcbroker1.Results.Count-1 do begin
      Prov.Add(Piece(Form1.brkrRpcbroker1.Results[I],'^',1));
      lstListBox1.Items.Add(Piece(Form1.brkrRpcbroker1.Results[I],'^',2));
    end;
  end;
  Nochange:=False;
end;


procedure TfrmConsults.lstListBox1Click(Sender: TObject);
begin
  Nochange:=True;
  If lstListBox1.Itemindex>-1 then begin
    Lb1index:=lstListBox1.Itemindex;
    edtEdit2.Text:=lstListBox1.Items[lstListBox1.Itemindex];
  end;
  lstListBox1.Visible:=False;
end;


procedure TfrmConsults.edtEdit3Change(Sender: TObject);
var I:Integer;
begin
  If Not frmConsults.Visible then exit;
  lstListBox2.Visible:=(Length(edtEdit3.Text)>2);
  If (lstListBox2.Items.Count=1)  and (edtEdit3.Text=lstListBox2.Items[0]) then Lb2index:=0;
  If (Not Nochange) and (lstListBox2.Visible) then begin
    EProv.Clear;  lstListBox2.Items.Clear;  Lb2index:=-1;
    Form1.Rpccallforlookup('200',edtEdit3.Text,'','','','I $D(^XUSEC("PROVIDER",+Y))');
    For I:=1 to Form1.brkrRpcbroker1.Results.Count-1 do begin
      EProv.Add(Piece(Form1.brkrRpcbroker1.Results[I],'^',1));
      lstListBox2.Items.Add(Piece(Form1.brkrRpcbroker1.Results[I],'^',2));
    end;
  end;
  Nochange:=False;
end;


procedure TfrmConsults.lstListBox2Click(Sender: TObject);
begin
  Nochange:=True;
  If lstListBox2.Itemindex>-1 then begin
    Lb2index:=lstListBox2.Itemindex;
    edtEdit3.Text:=lstListBox2.Items[lstListBox2.Itemindex];
  end;
  lstListBox2.Visible:=False;
end;


procedure TfrmConsults.Addtonotify(S:String);
var I:Integer;  S2:String;
begin
  If Not Contain(lblNotifylabel.Caption,S) then begin
    If lblNotifylabel.Caption<>'' then lblNotifylabel.Caption:=lblNotifylabel.Caption+'^';
    If (Prov.Count>0) and (Lb1index>-1) then lblNotifylabel.Caption:=lblNotifylabel.Caption+S+';'+Prov[Lb1index];
  end
  else begin
    S2:='';
    For I:=1 to Piececount(lblNotifylabel.Caption,U) do
       If Not Contain(Piece(lblNotifylabel.Caption,U,I),S) then S2:=S2+Piece(lblNotifylabel.Caption,U,I)+U
       else S2:=S2+Piece(Piece(lblNotifylabel.Caption,U,I),';',1)+';'+Prov[Lb1index];
    lblNotifylabel.Caption:=S2;
  end;
  If Not Contain(lblNotifylabelEP.Caption,S) then begin
    If lblNotifylabelEp.Caption<>'' then lblNotifylabelEp.Caption:=lblNotifylabelEp.Caption+'^';
    If (EProv.Count>0) and (Lb2index>-1) then lblNotifylabelEp.Caption:=lblNotifylabelEp.Caption+S+';'+EProv[Lb2index];
  end
  else begin
    S2:='';
    For I:=1 to Piececount(lblNotifylabelEp.Caption,U) do
       If Not Contain(Piece(lblNotifylabelEp.Caption,U,I),S) then S2:=S2+Piece(lblNotifylabelEp.Caption,U,I)+U
       else S2:=S2+Piece(Piece(lblNotifylabelEp.Caption,U,I),';',1)+';'+EProv[Lb2index];
    lblNotifylabelEp.Caption:=S2;
  end;
end;


procedure TfrmConsults.FormShow(Sender: TObject);
begin
  btnUploadButton.Enabled:=True;  btnCancelButton.Enabled:=True;
end;


procedure TfrmConsults.FormDestroy(Sender: TObject);
begin
  EProv.Free;  Prov.Free;
end;


end.
