unit uAdmassess_Shift_Printer_Selection;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, RPCConf1, TRpcb, Miscfp, Printers, Spin, jpeg,
  ExtCtrls, CheckLst;

type
  TfrmPrinters = class(TForm)
    lblLabel1: TLabel;    lblLabel2: TLabel;    lblLabel3: TLabel;
    lblHoldLabel: TLabel;
    lblRoomlabel: TLabel;
    lblWhichlabel: TLabel;
    edtEdit1: TEdit;
    lstPrinterbox: TListBox;
    memPrintMemo: TMemo;
    btnOKButton: TBitBtn;   btnCancelbutton: TBitBtn;
    spnedtSpinEdit1: TSpinEdit;
    imgImage1: TImage;     imgImage2: TImage;
    lblLabel4: TLabel;
    cbxComboBox1: TComboBox;
    lblViewLabel8: TLabel;
    btnDefPButton: TButton;
    pnlButtons: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btnCancelbuttonClick(Sender: TObject);
    procedure btnOKButtonClick(Sender: TObject);
    procedure edtEdit1Change(Sender: TObject);
    procedure imgImage1Click(Sender: TObject);
    procedure lstPrinterboxDblClick(Sender: TObject);
    procedure lstPrinterboxClick(Sender: TObject);
    procedure lblLabel4MouseEnter(Sender: TObject);
    procedure lblLabel4MouseLeave(Sender: TObject);
    procedure lblLabel4Click(Sender: TObject);
    procedure btnDefPButtonClick(Sender: TObject);
  private
    Debug:Boolean;
    Page:Integer;
    XMult,YMult:Real;
    procedure BelHeader(Page: Integer);
    Function FileitClb(Clb: TCheckListBox; L: TLabel):String;
    procedure Funcv3;
    procedure Hdr;
    function Inpbox(X:String): Boolean;
    function Notspec(S:String):String;
    procedure Pmadd1(S: String);
    procedure Pmadd2(C: TComponent;  S:String);
    procedure Printit(Pn:String);
    procedure Slaveprint;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmPrinters: TfrmPrinters;

implementation

uses uAdmassess_Shift_Main;

{$R *.DFM}

procedure TfrmPrinters.FormCreate(Sender: TObject);
begin
  //frmPrinters.Color:=$00D5A67B;
  Page:=0;
end;


procedure TfrmPrinters.btnOKButtonClick(Sender: TObject);
var I,Sel:Integer;
begin
  Sel:=-1;
  For I:=0 to lstPrinterBox.Items.Count-1 do
    If lstPrinterBox.Selected[I] then Sel:=I;
  If (Sel=-1) and (Not Inpbox(edtEdit1.Text)) then begin
    Mb('You have not selected a printer!','E');
    edtEdit1.Setfocus;  Exit;
  end;
end;


function TfrmPrinters.Inpbox(X:String): Boolean;
var I:Integer;
begin
  Inpbox:=False;
  For I:=0 to lstPrinterBox.Items.Count-1 do
    If lstPrinterBox.Items[I]=X then Inpbox:=True;
end;


procedure TfrmPrinters.Printit(Pn:String);
var I:Integer;
begin
  If Contain(Pn,'SLAVE') then Slaveprint
  else begin
    With Form1.brkrRpcbroker1 do begin
      RemoteProcedure:='NUPA PRINT';
      Param[0].Value:=Pn;  Param[0].Ptype:=literal;  Param[1].Ptype:=list;
    end;
    For I:=0 to memPrintmemo.Lines.Count-1 do begin
      Form1.brkrRpcbroker1.Param[1].Mult[Inttostr(I+1)]:=memPrintmemo.Lines[I];
    end;
    Form1.brkrRpcbroker1.Call;
    If Form1.brkrRpcbroker1.Results.Count>0 then
      If Strtoint(Piece(Form1.brkrRpcbroker1.Results[0],'^',1))<1 then
        Mb('ERROR!  '+Piece(Form1.brkrRpcbroker1.Results[0],'^',2)+' did not print!','E')
  end;
  edtEdit1.Setfocus;   Close;
end;


procedure TfrmPrinters.Slaveprint;
var I,IncY,Max_Y,Min_X,Page,Y:Integer;  OK:Boolean;
begin
  //Dots/inch multiplier bassed on a 600 DPI Laser
  XMult:=Getdevicecaps(Printer.Handle,LogpixelsX) / 600;
  YMult:=Getdevicecaps(Printer.Handle,LogpixelsY) / 600;
  If Debug then showmessage('slp 1');
  Min_X:=Trunc(150*XMult);  Max_Y:=Trunc(6000*YMult);
  Page:=1;  I:=0;  IncY:=Trunc(90*YMult);  Y:=Trunc(500*YMult);
  Printer.Begindoc;
  If Debug then showmessage('slp 2');
  BelHeader(1);
  If Debug then showmessage('slp 3');
  With Printer.Canvas do begin
    Font.Name:=memPrintmemo.Font.Name;
    Repeat
      If Contain(memPrintMemo.Lines[I],'Pager') then OK:=True  //special case for belongings
      else OK:=(Not Contain(memPrintMemo.Lines[I],'***  PATIENT')) and (Not Contain(memPrintMemo.Lines[I],'Page')) and (Not Contain(memPrintMemo.Lines[I],'Printed'));
      If OK then begin
        TextOut(Min_X+20,Y,memPrintMemo.Lines[I]);
        Y:=Y+IncY;
        If Y>(Max_Y-IncY) then begin
          Printer.Newpage;
          Inc(Page);  BelHeader(Page);  Y:=Trunc(500*YMult);
          Font.Name:=memPrintMemo.Font.Name;
        end;
      end;
      Inc(I);
    Until I>=memPrintMemo.Lines.Count;
  end;
  Printer.Enddoc;
  Mb('Print-out complete!','I');
end;


procedure TfrmPrinters.BelHeader(Page:Integer);
var R:TRect;  Max_X,Max_Y,Min_X:Integer;
begin
  Min_X:=Trunc(150*XMult);  Max_X:=Trunc(4700*XMult);  Max_Y:=Trunc(6000*YMult);
  R:=Rect(Trunc(170*XMult),Trunc(150*YMult),Trunc(400*XMult),Trunc(350*YMult));
  If Debug then showmessage('slph 1');
  With Printer.Canvas do begin
    Pen.Color:=clblack;  Brush.Color:=clblack;    Brush.Style:= bssolid;  Font.Name:='arial';
    Rectangle(Min_X,Trunc(50*YMult),Trunc(2050*XMult),Trunc(400*YMult));
    Stretchdraw(R,imgImage2.Picture.Graphic);
    If Debug then showmessage('slph 2');
    Font.Color:=clwhite;    Font.Size:=10;  Font.Style:=[fsitalic];
    TextOut(Trunc(450*XMult),Trunc(120*XMult),'Department of Veterans Affairs');
    If Contain(lblWhichlabel.Caption,'BEL') then TextOut(Trunc(450*XMult),Trunc(250*YMult),'Patient Belongings Inventory');
    If lblWhichlabel.Caption='FUNCV3' then TextOut(Trunc(450*XMult),Trunc(250*YMult),'Functional Assessment');
    MoveTo(Min_X,50);  Lineto(Min_X,Max_Y);  Lineto(Max_X,Max_Y);  Lineto(Max_X,50);  Lineto(Min_X,50);  //Outline
    If Debug then showmessage('slph 3');
    Brush.Color:=clwhite;    Brush.Style:= bsclear;  Font.Color:=clblack;
    Moveto(Trunc(1900*XMult),Trunc(400*YMult));      Lineto(Max_X,Trunc(400*YMult));
    TextOut(Trunc(2100*XMult),Trunc(120*XMult),'Patient: '+Piece(lblHoldlabel.Caption,'^',1)+' ('+Piece(lblHoldlabel.Caption,'^',2)+')');
    If Debug then showmessage('slph 4');
    TextOut(Trunc(2100*XMult),Trunc(250*YMult),'Printed: '+Datetostr(Date)+'@'+Timetostr(Time));
    TextOut(Trunc(4350*XMult),Trunc(250*YMult),'Page: '+Inttostr(Page));
    Font.Color:=clblack;   Font.Style:=[];
  end;
end;


procedure TfrmPrinters.FormShow(Sender: TObject);
var S,Ssn:String;
begin
  Ssn:=Piece(lblHoldlabel.Caption,'^',2);  S:=Ssn;
  If Contain(Ssn,'-') then S:=Piece(Ssn,'-',1)+Piece(Ssn,'-',2)+Piece(Ssn,'-',3);
  If Debug then SHowmessage('fs1');
  Form1.Rpccallforlookup('2',S,'.1','SSN','','');
  If Piece(Form1.brkrRpcbroker1.Results[0],'^',1)='1' then begin
    S:=Piece(Form1.brkrRpcbroker1.Results[1],'^',3);
    If Debug then Showmessage('fs2');
    Form1.Rpccallforlookup('8989.5',S,'1','','','I $P(^(0),U,2)=125,$p(^(0),U,3)=169');
    If Piece(Form1.brkrRpcbroker1.Results[0],'^',1)='1' then begin
      S:=Piece(Form1.brkrRpcbroker1.Results[1],'^',3);
      If Debug then Showmessage('fs3');
      If S<>'' then begin
        Form1.Rpccallforlookup('3.5','`'+S,'','','','');
        lstPrinterBox.Clear;   lstPrinterBox.Items.Add('SLAVE PRINTER');
        lstPrinterBox.Items.Add(Piece(Form1.brkrRpcbroker1.Results[1],'^',2));
      end;
    end;
  end;
  If Debug then Showmessage('fs4');
  If lblWhichlabel.Caption='FUNCV3' then Funcv3;
end;


procedure TfrmPrinters.Funcv3;
begin
  memPrintMemo.Clear;  Hdr;
  If Debug then Showmessage('Belv 1');
  Pmadd1(Form1.lblFuncv3Label1.Caption);
  Pmadd1(Copy(Form1.lblFuncv3Label3.Caption,3,78));
  Pmadd1('  '+Copy(Form1.lblFuncv3Label3.Caption,82,99));
  If Form1.Anychecked(Form1.lstFuncv3CheckListBox1) then begin
    Pmadd1(' ');
    Pmadd1(Form1.lblFuncv3Label7.Caption);
    Pmadd1('  '+Form1.lblFuncv3Label8.Caption);
    Pmadd1(FileitCLB(Form1.lstFuncv3CheckListBox1,Form1.lblFuncv3Label10));
    Pmadd1(Form1.lblFuncv3Label12.Caption+': '+Inttostr(Form1.spnedtFuncv3SpinEdit1.Value));
  end;
  If Form1.Anychecked(Form1.lstFuncv3CheckListBox2) then begin
    Pmadd1(' ');
    Pmadd1(Form1.lblFuncv3Label9.Caption);
    Pmadd1(FileitCLB(Form1.lstFuncv3CheckListBox2,Form1.lblFuncv3Label11));
    Pmadd1(Form1.lblFuncv3Label13.Caption+': '+Inttostr(Form1.spnedtFuncv3SpinEdit2.Value));
  end;
  If Form1.Anychecked(Form1.lstFuncv3CheckListBox3) then begin
    Pmadd1(' ');
    Pmadd1(Form1.lblFuncv3Label14.Caption);
    Pmadd1('  '+Form1.lblFuncv3Label15.Caption);
    Pmadd1(FileitCLB(Form1.lstFuncv3CheckListBox3,Form1.lblFuncv3Label16));
    Pmadd1(Form1.lblFuncv3Label23.Caption+': '+Inttostr(Form1.spnedtFuncv3SpinEdit3.Value));
  end;
  If Form1.Anychecked(Form1.lstFuncv3CheckListBox4) then begin
    Pmadd1(' ');
    Pmadd1(Form1.lblFuncv3Label17.Caption);
    Pmadd1(FileitCLB(Form1.lstFuncv3CheckListBox4,Form1.lblFuncv3Label18));
    Pmadd1(Form1.lblFuncv3Label24.Caption+': '+Inttostr(Form1.spnedtFuncv3SpinEdit4.Value));
  end;
  If Form1.Anychecked(Form1.lstFuncv3CheckListBox5) then begin
    Pmadd1(' ');
    Pmadd1(Form1.lblFuncv3Label19.Caption);
    Pmadd1(FileitCLB(Form1.lstFuncv3CheckListBox5,Form1.lblFuncv3Label20));
    Pmadd1(Form1.lblFuncv3Label25.Caption+': '+Inttostr(Form1.spnedtFuncv3SpinEdit5.Value));
  end;
  If Form1.Anychecked(Form1.lstFuncv3CheckListBox6) then begin
    Pmadd1(' ');
    Pmadd1(Form1.lblFuncv3Label21.Caption);
    Pmadd1(FileitCLB(Form1.lstFuncv3CheckListBox6,Form1.lblFuncv3Label22));
    Pmadd1(Form1.lblFuncv3Label26.Caption+': '+Inttostr(Form1.spnedtFuncv3SpinEdit6.Value));
  end;
  Pmadd1(' ');
  If Form1.rgrpFuncv3RadioGroup1.Itemindex>-1 then Pmadd1(Form1.rgrpFuncv3RadioGroup1.Caption+': '+Form1.rgrpFuncv3RadioGroup1.Items[Form1.rgrpFuncv3RadioGroup1.Itemindex]);
  If Form1.rgrpFuncv3RadioGroup2.Itemindex>-1 then Pmadd1(Form1.rgrpFuncv3RadioGroup2.Caption+': '+Form1.rgrpFuncv3RadioGroup2.Items[Form1.rgrpFuncv3RadioGroup2.Itemindex]);
end;


function TfrmPrinters.FileitClb(Clb:TCheckListBox;  L:TLabel):String;
var I:Integer;  S:String;
begin
  If Not Clb.Visible then exit;
  S:=Form1.Removestar(L.Caption);
  If Not Contain(S,':') then S:=S+': ';
  If Not Form1.Anychecked(Clb) then S:=S+' None';
  For I:=0 to Clb.Items.Count-1 do
    If Clb.Checked[I] then begin
      S:=S+Clb.Items[I];
      If Form1.AnycheckedDown(Clb,I) then S:=S+', ';
      If Length(S)>60 then S:='  ';
    end;
  If S<>'  ' then
   If (Not Contain(S,'None')) and (Copy(S,Length(S)-2,2)=', ') then S:=Copy(S,1,Length(S)-2);
  Result:=S;
end;


function TfrmPrinters.Notspec(S:String):String;
begin
  Notspec:=S;
  If (S='') or (S='  /  /  ')  or (S='  :  ') then Notspec:='Not specified';
end;


procedure TfrmPrinters.Hdr;
var S:String;
begin
  memPrintMemo.Lines.Add(chr(12)+'             ***  PATIENT BELONGINGS LIST  ***');
  memPrintMemo.Lines.Add('');
  S:=Piece(lblHoldlabel.Caption,'^',1)+'  '+Piece(lblHoldlabel.Caption,'^',2)+'                                                  ';
  Inc(Page);  S:=Copy(S,1,60)+' Page: '+Inttostr(Page);
  memPrintMemo.Lines.Add(S);
  memPrintMemo.Lines.Add('Ward: '+Piece(lblHoldlabel.Caption,'^',4)+'      Printed: '+Datetostr(Date)+'  '+Timetostr(Time));
  memPrintMemo.Lines.Add('');
end;


procedure TfrmPrinters.Pmadd1(S:String);
begin
  memPrintMemo.Lines.Add(S);
  If (memPrintMemo.Lines.Count mod 60)=0 then Hdr;
end;


procedure TfrmPrinters.Pmadd2(C:TComponent;  S:String);
var I:Integer;  S2:String;
begin
  If Debug then Showmessage('pmadd2 1');
  S:=Form1.Removestar(S);
  If Debug then Showmessage('pmadd2 2');
  If (C is TCheckListBox) and (Form1.Anychecked(C as TCheckListBox)) then begin
    If S<>'' then memPrintMemo.Lines.Add(S+':');
    For I:=0 to (C as TCheckListBox).Items.Count-1 do begin
      If (C as TCheckListBox).Checked[I] then memPrintMemo.Lines.Add('    '+(C as TCheckListBox).Items[I]);
      If (memPrintMemo.Lines.Count mod 60)=0 then Hdr;
    end;
  end;
  If Debug then Showmessage('pmadd2 3');
  If (C is TMemo) and ((C as TMemo).Lines.Count>0) then begin
    If S<>'' then memPrintMemo.Lines.Add('  '+S+':');
    For I:=0 to (C as TMemo).Lines.Count-1 do begin
      memPrintMemo.Lines.Add('    '+(C as TMemo).Lines[I]);
      If (memPrintMemo.Lines.Count mod 60)=0 then Hdr;
    end;
  end;
  If Debug then Showmessage('pmadd2 4');
  If (C is TRadiogroup) and ((C as TRadiogroup).Itemindex>-1) then begin
    S2:=(C as TRadiogroup).Caption; 
    If S2<>'' then begin
      If S2[1]='*' then S2:=Piece(S2,'*',2);
      If S2[1]=' ' then S2:=Copy(S2,2,999);
      If S2[Length(S2)]='*' then S2:=Piece(S2,'*',1);
    end;
    If Debug then Showmessage('pmadd2 4.1');
    memPrintMemo.Lines.Add(S+S2+': '+(C as TRadiogroup).Items[(C as TRadiogroup).Itemindex]);
  end;
  If Debug then Showmessage('pmadd2 5');
  If (memPrintMemo.Lines.Count mod 60)=0 then Hdr;
end;


procedure TfrmPrinters.edtEdit1Change(Sender: TObject);
var I:Integer;
begin
  lstPrinterBox.Items.Clear;
  If edtEdit1.Text<>'' then Form1.Rpccallforlookup('3.5',edtEdit1.Text,'','','','')
  else lstPrinterBox.Items.Add('SLAVE PRINTER');
  For I:=1 to (Form1.brkrRpcbroker1.Results.Count-1) do
    lstPrinterBox.Items.Add(Piece(Form1.brkrRpcbroker1.Results[I],'^',2));
  If lstPrinterBox.Items.Count=1 then edtEdit1.Text:=lstPrinterBox.Items[0];
end;


procedure TfrmPrinters.lstPrinterBoxDblClick(Sender: TObject);
begin
  Printit(lstPrinterBox.Items[lstPrinterBox.Itemindex]);
end;


procedure TfrmPrinters.btnCancelbuttonClick(Sender: TObject);
begin
  Close;
end;


procedure TfrmPrinters.lblLabel4Click(Sender: TObject);
begin
  lblViewLabel8.Visible:=True;
  cbxCombobox1.Visible:=True;  cbxCombobox1.Text:=Piece(lblLabel4.Caption,': ',2);
  btnDefPButton.Visible:=True;
end;


procedure TfrmPrinters.btnDefPButtonClick(Sender: TObject);
var S:String;
begin
  If cbxCombobox1.ItemIndex>-1 then begin
    Mb('This can take a while.  Press OK to start.  You''ll receive another message when done.','I');
    screen.cursor:=crhourglass;
    SetDefaultPrinter(cbxCombobox1.Items[cbxCombobox1.ItemIndex]);
    Printer.Printers[Printer.PrinterIndex]:=cbxCombobox1.Items[cbxCombobox1.ItemIndex];
    S:=GetDefaultPrinterName;
    If S='' then S:='None';
    lblLabel3.Caption:='Default network printer: '+S;
    Mb('Default printer changed.','I');
    screen.cursor:=crdefault;
  end;
  lblViewLabel8.Visible:=False;  cbxCombobox1.Visible:=False;  btnDefPButton.Visible:=False;
end;


procedure TfrmPrinters.lblLabel4MouseEnter(Sender: TObject);
begin
 (Sender as TLabel).Font.Color:=clred;
end;


procedure TfrmPrinters.lblLabel4MouseLeave(Sender: TObject);
begin
 (Sender as TLabel).Font.Color:=clblack;
end;


procedure TfrmPrinters.lstPrinterBoxClick(Sender: TObject);
begin
  edtEdit1.Text:=lstPrinterBox.Items[lstPrinterBox.Itemindex];
end;


procedure TfrmPrinters.imgImage1Click(Sender: TObject);
begin
  If lblLabel2.Visible then begin
    Slaveprint;  Close;
  end;
end;


end.
